VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.UserControl MDITaskBar 
   Alignable       =   -1  'True
   ClientHeight    =   510
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3990
   PropertyPages   =   "MDITaskBar.ctx":0000
   ScaleHeight     =   510
   ScaleWidth      =   3990
   ToolboxBitmap   =   "MDITaskBar.ctx":0025
   Begin MSComctlLib.ImageList ilsMDITaskBar 
      Left            =   1680
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
   End
   Begin MSComctlLib.TabStrip tabMDITaskBar 
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3855
      _ExtentX        =   6800
      _ExtentY        =   661
      Style           =   1
      HotTracking     =   -1  'True
      Placement       =   1
      _Version        =   393216
   End
End
Attribute VB_Name = "MDITaskBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

Private ProgramSetMDIBar As Boolean 'THIS IS NECESSARY AND IS DESCRIBED
                                   'IN THE SETACTIVEFORMONTASKBAR METHOD BELOW!!!

Private Const TabMDIButtonAdjustment = 34 'These are necessary for adjustments, as decribed in the
Private Const TabMDISideAdjustment = 10 'adjusttaskbarbuttonwidths method below

'The next object holds the forms collection, for implementation of an arbitrary
'number of forms.
Private FormsCollection As New Collection

'Event Declarations:
Event Click() 'MappingInfo=tabMDITaskBar,tabMDITaskBar,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event ButtonClick(Key As Variant)
Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=tabMDITaskBar,tabMDITaskBar,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=tabMDITaskBar,tabMDITaskBar,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=tabMDITaskBar,tabMDITaskBar,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
'Default Property Values:
Const m_def_FormCount = 0
'Property Variables:
Dim m_FormCount As Long

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=tabMDITaskBar,tabMDITaskBar,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_ProcData.VB_Invoke_Property = "StandardFont;Appearance"
Attribute Font.VB_UserMemId = -512
    Set Font = tabMDITaskBar.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set tabMDITaskBar.Font = New_Font
    PropertyChanged "Font"
End Property

Private Sub tabMDITaskBar_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseDown(Button, Shift, x, y)
End Sub

Private Sub tabMDITaskBar_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub tabMDITaskBar_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseUp(Button, Shift, x, y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=tabMDITaskBar,tabMDITaskBar,-1,WhatsThisHelpID
Public Property Get WhatsThisHelpID() As Long
Attribute WhatsThisHelpID.VB_Description = "Returns/sets an associated context number for an object."
    WhatsThisHelpID = tabMDITaskBar.WhatsThisHelpID
End Property

Public Property Let WhatsThisHelpID(ByVal New_WhatsThisHelpID As Long)
    tabMDITaskBar.WhatsThisHelpID() = New_WhatsThisHelpID
    PropertyChanged "WhatsThisHelpID"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=tabMDITaskBar,tabMDITaskBar,-1,ToolTipText
Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
    ToolTipText = tabMDITaskBar.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    tabMDITaskBar.ToolTipText() = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=tabMDITaskBar,tabMDITaskBar,-1,MousePointer
Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    MousePointer = tabMDITaskBar.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
    tabMDITaskBar.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=tabMDITaskBar,tabMDITaskBar,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
    Set MouseIcon = tabMDITaskBar.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set tabMDITaskBar.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
    hWnd = UserControl.hWnd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,hDC
Public Property Get hDC() As Long
Attribute hDC.VB_Description = "Returns a handle (from Microsoft Windows) to the object's device context."
    hDC = UserControl.hDC
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,HasDC
Public Property Get HasDC() As Boolean
Attribute HasDC.VB_Description = "Determines whether a unique display context is allocated for the control."
    HasDC = UserControl.HasDC
End Property

Private Sub UserControl_InitProperties()
    m_FormCount = m_def_FormCount
    UserControl.Extender.Align = vbAlignBottom
    UserControl.Extender.Visible = False
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Set tabMDITaskBar.Font = PropBag.ReadProperty("Font", Ambient.Font)
    tabMDITaskBar.WhatsThisHelpID = PropBag.ReadProperty("WhatsThisHelpID", 0)
    tabMDITaskBar.ToolTipText = PropBag.ReadProperty("ToolTipText", "")
    tabMDITaskBar.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    m_FormCount = PropBag.ReadProperty("FormCount", m_def_FormCount)
End Sub

Private Sub UserControl_Terminate()
    Set tabMDITaskBar.ImageList = Nothing
    ilsMDITaskBar.ListImages.Clear
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Font", tabMDITaskBar.Font, Ambient.Font)
    Call PropBag.WriteProperty("WhatsThisHelpID", tabMDITaskBar.WhatsThisHelpID, 0)
    Call PropBag.WriteProperty("ToolTipText", tabMDITaskBar.ToolTipText, "")
    Call PropBag.WriteProperty("MousePointer", tabMDITaskBar.MousePointer, 0)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("FormCount", m_FormCount, m_def_FormCount)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Function AddFormToTaskBar(FormToAdd As Object, Optional Key As Variant) As Variant
    On Error Resume Next 'This is because the icon may be added twice for forms with the same name!
    If Not TypeOf FormToAdd Is Form Then Exit Function
    If Not FormToAdd.MDIChild Then Exit Function
    If IsMissing(Key) Then Key = FormToAdd.Tag
    FormsCollection.Add FormToAdd, Key 'Add it to the the collection...
    If m_FormCount = 0 Then UserControl.Extender.Visible = True
    m_FormCount = m_FormCount + 1
    ilsMDITaskBar.ListImages.Add , FormToAdd.Name, FormToAdd.Icon
    With tabMDITaskBar
        'This adds the form to the end of the MDI taskbar, just like windows, it sets the unique key
        'of the tab to the form TAG, it adds the caption of the form to the tab caption, and it
        'accesses the image in the image list associated with this form by the form NAME - as described
        'above!
        Set .ImageList = ilsMDITaskBar
        .Tabs.Add .Tabs.Count + 1, Key, FormToAdd.Caption, FormToAdd.Name
        .Tabs(.Tabs.Count).ToolTipText = FormToAdd.Caption
    End With
    AdjustTaskBarButtonWidths 'Forces the control to readjust to perfect.
End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Function RemoveFormFromTaskBar(FormToRemove As Object, Optional Key As Variant) As Variant
    On Error GoTo cancel
    'This deletes the tab from the control by accessing the key of the tab as the form TAG,
    'which was set in the addformtotaskbar method above
    If IsMissing(Key) Then Key = FormToRemove.Tag
    FormsCollection.Remove Key 'The tag is the key!
    m_FormCount = m_FormCount - 1
    If m_FormCount = 0 Then UserControl.Extender.Visible = False 'RaiseEvent FormCountHitZero
    tabMDITaskBar.Tabs.Remove Key
    AdjustTaskBarButtonWidths 'Forces the control to readjust to perfect.
    Exit Function
cancel:
    MsgBox Err.Description
End Function
 
Private Sub AdjustTaskBarButtonWidths()
    On Error Resume Next 'just in case
    With tabMDITaskBar
        'The next line looks intricate but its not.  The reason while there are all the
        'adjustment constants is because there is a finite distance between each button
        'and there is a finite distance between the left and right edges of the MDI form.
        'Thus to fit the buttons all the way across I needed to fiddle around a while.
        'These adjustments work great, if you can make it better, go ahead!
        .TabFixedWidth = Int(.Width / .Tabs.Count) - Int((TabMDIButtonAdjustment * .Tabs.Count) / .Tabs.Count) - Int(2 * TabMDISideAdjustment)
        .TabWidthStyle = tabFixed 'Required to force the tabstrip to redraw the buttons
    End With
End Sub

Private Sub UserControl_Resize()
    'This procedure is necessary to adjust the MDItaskbar when the MDI form adjusts its dimensions
    On Error Resume Next 'just in case
    tabMDITaskBar.Width = UserControl.Width
    UserControl.Height = tabMDITaskBar.Height
    AdjustTaskBarButtonWidths 'Necessary to force the buttons to perfect widths
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14
Public Function SetActiveFormOnTaskBar(FormToSet As Object, Optional Key As Variant) As Variant
    On Error GoTo cancel
    'This is set so that the click event in the tab strip is not fired
    'otherwise, the tabstrip will go into an infinite loop of reclicking due to the activate
    'event handlers in the forms themselves
    If IsMissing(Key) Then Key = FormToSet.Tag
    ProgramSetMDIBar = True
    'This pushes down the button and pops up all the others - the reason why i chose the tabstrip and not
    'the toolbar is that the toolbar, even with grouped buttons has a problem with this.  the other method
    'is to use checked buttons but then you have to use event handlers in activate AND deactivate events
    'to make it work right
    tabMDITaskBar.Tabs(Key).Selected = True
    ProgramSetMDIBar = False 'BE SURE TO DO THIS!!
    Exit Function
cancel:
    MsgBox Err.Description
End Function

Public Sub ShowAbout()
Attribute ShowAbout.VB_UserMemId = -552
Attribute ShowAbout.VB_MemberFlags = "40"
    dlgAbout.Show vbModal
    Unload dlgAbout
    Set dlgAbout = Nothing
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,1,2,0
Public Property Get FormCount() As Long
Attribute FormCount.VB_MemberFlags = "400"
    FormCount = m_FormCount
End Property

Public Property Let FormCount(ByVal New_FormCount As Long)
    If Ambient.UserMode = False Then Err.Raise 387
    If Ambient.UserMode Then Err.Raise 382
    m_FormCount = New_FormCount
    PropertyChanged "FormCount"
End Property

Private Sub tabMDITaskBar_Click()
    'The following test is necessary to prevent an infinite loop from various click and activate
    'handlers, as described in the MDITaskBarCode module!!!!
    If ProgramSetMDIBar Then Exit Sub
    'Now, let's say you don't know how many forms you'll have so you can't write all the code for them.
    'In this case, you are using a formscollection...
    'To access the form you would...
    FormsCollection(tabMDITaskBar.SelectedItem.Key).ZOrder
    RaiseEvent ButtonClick(tabMDITaskBar.SelectedItem.Key)
    RaiseEvent Click
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ActiveControl
Public Property Get ActiveControl() As Object
Attribute ActiveControl.VB_Description = "Returns the control that has focus."
    Set ActiveControl = UserControl.ActiveControl
End Property
